aboutsummaryrefslogtreecommitdiffstats
path: root/package/base-files
diff options
context:
space:
mode:
authorYousong Zhou <yszhou4tech@gmail.com>2017-01-01 01:06:37 +0800
committerFelix Fietkau <nbd@nbd.name>2017-01-05 11:09:14 +0100
commit6f61d8511eccf2736fd7f430aff2c98c595fa4b9 (patch)
tree04ed2b944470b00af1a94d54702e13e5ed198912 /package/base-files
parentd53fcdefbf5443e0cc404cead7ba48f9978b81f3 (diff)
downloadupstream-6f61d8511eccf2736fd7f430aff2c98c595fa4b9.tar.gz
upstream-6f61d8511eccf2736fd7f430aff2c98c595fa4b9.tar.bz2
upstream-6f61d8511eccf2736fd7f430aff2c98c595fa4b9.zip
base-files: export x86 platform upgrade functions to common.sh
Signed-off-by: Yousong Zhou <yszhou4tech@gmail.com>
Diffstat (limited to 'package/base-files')
-rw-r--r--package/base-files/files/lib/upgrade/common.sh90
1 files changed, 90 insertions, 0 deletions
diff --git a/package/base-files/files/lib/upgrade/common.sh b/package/base-files/files/lib/upgrade/common.sh
index 4d0e6d5f17..8cfce71999 100644
--- a/package/base-files/files/lib/upgrade/common.sh
+++ b/package/base-files/files/lib/upgrade/common.sh
@@ -206,6 +206,96 @@ get_magic_long() {
(get_image "$@" | dd bs=4 count=1 | hexdump -v -n 4 -e '1/1 "%02x"') 2>/dev/null
}
+export_bootdevice() {
+ local cmdline uuid disk uevent
+ local MAJOR MINOR DEVNAME DEVTYPE
+
+ if read cmdline < /proc/cmdline; then
+ case "$cmdline" in
+ *block2mtd=*)
+ disk="${cmdline##*block2mtd=}"
+ disk="${disk%%,*}"
+ ;;
+ *root=*)
+ disk="${cmdline##*root=}"
+ disk="${disk%% *}"
+ ;;
+ esac
+
+ case "$disk" in
+ PARTUUID=[a-f0-9][a-f0-9][a-f0-9][a-f0-9][a-f0-9][a-f0-9][a-f0-9][a-f0-9]-02)
+ uuid="${disk#PARTUUID=}"
+ uuid="${uuid%-02}"
+ for disk in $(find /dev -type b); do
+ set -- $(dd if=$disk bs=1 skip=440 count=4 2>/dev/null | hexdump -v -e '4/1 "%02x "')
+ if [ "$4$3$2$1" = "$uuid" ]; then
+ uevent="/sys/class/block/${disk##*/}/uevent"
+ break
+ fi
+ done
+ ;;
+ /dev/*)
+ uevent="/sys/class/block/${disk##*/}/uevent"
+ ;;
+ esac
+
+ if [ -e "$uevent" ]; then
+ . "$uevent"
+
+ export BOOTDEV_MAJOR=$MAJOR
+ export BOOTDEV_MINOR=$MINOR
+ return 0
+ fi
+ fi
+
+ return 1
+}
+
+export_partdevice() {
+ local var="$1" offset="$2"
+ local uevent MAJOR MINOR DEVNAME DEVTYPE
+
+ for uevent in /sys/class/block/*/uevent; do
+ . "$uevent"
+ if [ $BOOTDEV_MAJOR = $MAJOR -a $(($BOOTDEV_MINOR + $offset)) = $MINOR -a -b "/dev/$DEVNAME" ]; then
+ export "$var=$DEVNAME"
+ return 0
+ fi
+ done
+
+ return 1
+}
+
+get_partitions() { # <device> <filename>
+ local disk="$1"
+ local filename="$2"
+
+ if [ -b "$disk" -o -f "$disk" ]; then
+ v "Reading partition table from $filename..."
+
+ local magic="$(hexdump -v -n 2 -s 0x1FE -e '1/2 "0x%04X"' "$disk")"
+ if [ "$magic" != 0xAA55 ]; then
+ v "Invalid partition table on $disk"
+ exit
+ fi
+
+ rm -f "/tmp/partmap.$filename"
+
+ local part
+ for part in 1 2 3 4; do
+ set -- $(hexdump -v -n 12 -s "$((0x1B2 + $part * 16))" -e '3/4 "0x%08X "' "$disk")
+
+ local type="$(($1 % 256))"
+ local lba="$(($2))"
+ local num="$(($3))"
+
+ [ $type -gt 0 ] || continue
+
+ printf "%2d %5d %7d\n" $part $lba $num >> "/tmp/partmap.$filename"
+ done
+ fi
+}
+
jffs2_copy_config() {
if grep rootfs_data /proc/mtd >/dev/null; then
# squashfs+jffs2